<template>
  <div>
    <filter-panel/>
    <ob-table
        ref="ob-table"
        :columns="columns"
        :functionalPanel="true"
        :filterButtons="isClicar ? filterButtons : []"
        @select="onSelection"
        @on-change-filter-button="onChangeFilterButton"
        is-fixed-header
        :is-functional-sort="false"
        :is-functional-group="false"
        :remote-opt="{
          method: getOrders,
          arguments: {
            url: $route.query.tab
          }
        }"
        :remote-trigger="$route.query"
        data-qa="orderListTable"
        class="orders-page"
    >

      <div slot="typeOrder" slot-scope="{data}">
        <type-order :order="data.item"/>
      </div>
      <div slot="caution" slot-scope="{data}">
        <caution :info="data.item"/>
      </div>
      <div slot="isNumberOrder" slot-scope="{data}">
        <number-order :item="data.item"/>
      </div>
      <div slot="cargoType" slot-scope="{data}">
        <cargo-type :data="data.item"/>
      </div>
      <div slot="route" slot-scope="{data}">
        <routes
            :start-address="data.item.fromLocationTitle"
            :end-address="data.item.toLocationTitle"
            :count="0"
        />
      </div>

      <table-is-empty slot="noneContent"/>

    </ob-table>
  </div>

</template>

<script>
  import FilterPanel from "../../filterPanel";
  import ObTable from "common-components/src/obComponents/obTable";
  import TypeOrder from "../slots/typeOrder";
  import Caution from "../slots/caution";
  import NumberOrder from "../slots/numberOrder";
  import CargoType from "../slots/cargoType";
  import Routes from "../slots/routes";
  import TableIsEmpty from "../tableIsEmpty";
  import commonMethods from '@/mixins/order-list-mixin.js';
  import {DateTime} from "luxon";
  import {formatNumber} from "common-components/src/helpers/common";

  export default {
    name: "client",
    components: {
      FilterPanel,
      ObTable,
      TypeOrder,
      Caution,
      NumberOrder,
      CargoType,
      Routes,
      TableIsEmpty
    },
    mixins: [
      commonMethods
    ],
    data() {
      return {
        filterButtons: [
          {
            title: 'Все',
            uuid: 'EXECUTED',
            _isActive: true
          },
          {
            title: 'Отменён',
            uuid: 'CANCELED',
            _isActive: false
          },
          {
            title: 'Завершённый',
            uuid: '',
            _isActive: false
          }
        ],
        columns: [
          {
            title: '№ заказа клиента',
            key: 'number',
            slotName: 'isNumberOrder'
          },
          {
            title: 'Внешний № заказа клиента',
            key: 'externalNumber',
            html: ({externalNumber}) => this.transformText(externalNumber)
          },
          {
            title: 'дата создания',
            key: 'createdAt',
            html: (data) => data.createdAt
              ? DateTime.fromISO(data.createdAt).toFormat("dd.MM.yyyy")
              : DateTime.local().toFormat("dd.MM.yyyy"),
          },
          {
            title: 'модальность',
            key: 'cargoTypeTitle',
            slotName: 'cargoType'
          },
          {
            title: 'статус',
            key: 'statusTitle',
          },
          {
            title: 'Маршрут',
            key: 'route',
            slotName: 'route'
          },
          {
            title: "Грузовладелец",
            key: "clientTitle"
          },
          {
            title: 'План: погрузка',
            key: 'arriveOrDepartureDt'
          },
          {
            title: 'сумма без ндс',
            key: 'tariffWithoutVat',
            isAlignRight: true,
            html: ({tariffWithoutVat}) =>
              `<div class="price-right">
                <span style="white-space: nowrap;">
                  ${formatNumber(tariffWithoutVat / 100, {dot: 2}) + " ₽"}
                </span>
              </div>`
          },
          {
            title: this.isTab === "carrier" ? 'НДС перевозчика' : 'ндс',
            key: 'vatValue',
            isAlignRight: true,
            html: ({vatValue}) =>
              `<div class="price-right">
                <span style="white-space: nowrap;">
                  ${formatNumber(vatValue / 100, {dot: 2}) + " ₽"}
                </span>
              </div>`
          },
          {
            title: 'сумма итого',
            key: 'tariffRur',
            isAlignRight: true,
            html: ({tariffRur}) =>
              `<div class="price-right">
                <span style="white-space: nowrap;">
                  ${formatNumber(tariffRur / 100, {dot: 2}) + " ₽"}
                </span>
              </div>`
          }
        ]
      }
    }
  }
</script>